CREATE OR REPLACE
PROCEDURE SCO_IMPORT.IMPORT_GIROFLE IS

--
-- Procédure de migration de SCO_IMPORT vers SCO_SCOLARITE du 21/02/2013 à exécuter depuis le user GRHUM
--
-- Rem : fichier encodé UTF-8

--
--
-- Fichier : 5/5
-- Type : PLSQL
-- Schema : SCO_IMPORT
-- Numero de version : 
-- Date de publication : 21/02/2013
-- Auteur(s) : Association Cocktail
--
--

BEGIN

	-- Introduction
	DBMS_OUTPUT.PUT_LINE('Démarrage de l importation des données...');
  
 -- Vidage des tables d'import
  	EXECUTE IMMEDIATE('DELETE FROM SCO_IMPORT.Z_ID');
    EXECUTE IMMEDIATE('DELETE FROM SCO_SCOLARITE.LIEN');
  	EXECUTE IMMEDIATE('DELETE FROM SCO_SCOLARITE.AP');
  	EXECUTE IMMEDIATE('DELETE FROM SCO_SCOLARITE.EC'); 
    EXECUTE IMMEDIATE('DELETE FROM SCO_SCOLARITE.UE');  
    EXECUTE IMMEDIATE('DELETE FROM SCO_SCOLARITE.PARCOURS');  
    EXECUTE IMMEDIATE('DELETE FROM SCO_SCOLARITE.DIPLOME');    
  	EXECUTE IMMEDIATE('DELETE FROM SCO_SCOLARITE.COMPOSANT');  
  	EXECUTE IMMEDIATE('DELETE FROM SCO_SCOLARITE.DOMAINE');  
    EXECUTE IMMEDIATE('DELETE FROM SCO_SCOLARITE.SPECIALITE');  
    EXECUTE IMMEDIATE('DELETE FROM SCO_SCOLARITE.MODE_AP');
    EXECUTE IMMEDIATE('DELETE FROM SCO_SCOLARITE.TYPE_AP');
	-- EXECUTE IMMEDIATE('TRUNCATE TABLE SCO_SCOLARITE.GRADE_UNIVERSITAIRE');   
	-- EXECUTE IMMEDIATE('TRUNCATE TABLE SCO_IMPORT.IMPORT_SPECIALISATION');  
	-- EXECUTE IMMEDIATE('TRUNCATE TABLE SCO_IMPORT.IMPORT_VOCATION');
	-- EXECUTE IMMEDIATE('TRUNCATE TABLE SCO_SCOLARITE.TYPE_FORMATION');  
	-- EXECUTE IMMEDIATE('TRUNCATE TABLE SCO_SCOLARITE.TYPE_ORGANISATION'); 
	DBMS_OUTPUT.PUT_LINE('Tables de SCO_SCOLARITE vidées');
  	COMMIT;

  	-- Alimentation des tables temporaires
	INSERT INTO SCO_IMPORT.Z_ID (ID_SOUR, ID_DEST, ID_TYPE)
  	SELECT SCO_IMPORT.IMPORT_AP.ID_AP, SCO_SCOLARITE.COMPOSANT_SEQ.nextval, 'AP' FROM SCO_IMPORT.IMPORT_AP;
  	INSERT INTO SCO_IMPORT.Z_ID (ID_SOUR, ID_DEST, ID_TYPE)
  	SELECT SCO_IMPORT.IMPORT_EC.ID_EC, SCO_SCOLARITE.COMPOSANT_SEQ.nextval, 'EC' FROM SCO_IMPORT.IMPORT_EC;
  	INSERT INTO SCO_IMPORT.Z_ID (ID_SOUR, ID_DEST, ID_TYPE)
  	SELECT SCO_IMPORT.IMPORT_UE.ID_UE, SCO_SCOLARITE.COMPOSANT_SEQ.nextval, 'UE' FROM SCO_IMPORT.IMPORT_UE;
  	INSERT INTO SCO_IMPORT.Z_ID (ID_SOUR, ID_DEST, ID_TYPE)
  	SELECT SCO_IMPORT.IMPORT_DIPLOME.ID_DIPLOME, SCO_SCOLARITE.COMPOSANT_SEQ.nextval, 'DI' FROM SCO_IMPORT.IMPORT_DIPLOME;
  	DBMS_OUTPUT.PUT_LINE('Alimentation des tables temporaires : OK');
 
  	-- Insertion des données de DOMAINE
	INSERT INTO SCO_SCOLARITE.DOMAINE (ID_DOMAINE, CODE, LC_DOMAINE, LL_DOMAINE, IS_READ_ONLY)
  	SELECT ID_DOMAINE, CODE, LIBELLE_COURT, LIBELLE, '1' FROM SCO_IMPORT.IMPORT_DOMAINE;
  	DBMS_OUTPUT.PUT_LINE('Alimentation de la table Domaines : OK');

  	-- Insertion des données de SPECIALITES
	INSERT INTO SCO_SCOLARITE.SPECIALITE (ID_SPECIALITE, CODE, LC_SPECIALITE, LL_SPECIALITE, IS_READ_ONLY)
  	SELECT ID_SPECIALITE, CODE, LIBELLE_COURT, LIBELLE, '1' FROM SCO_IMPORT.IMPORT_SPECIALITE;
  	DBMS_OUTPUT.PUT_LINE('Alimentation de la table Spécialités : OK');
  
  	-- Insertion des données de MODE_AP
	INSERT INTO SCO_SCOLARITE.MODE_AP (ID_MODE_AP, CODE, LIBELLE, IS_READ_ONLY)
  	SELECT ID_MODE_AP, CODE, LIBELLE, '1' FROM SCO_IMPORT.IMPORT_MODE_AP;
  	DBMS_OUTPUT.PUT_LINE('Alimentation de la table Modes d''AP : OK');

   	-- Insertion des données de TYPE_AP
	INSERT INTO SCO_SCOLARITE.TYPE_AP (ID_TYPE_AP, CODE, LIBELLE, IS_READ_ONLY)
 	SELECT ID_TYPE_AP, CODE, LIBELLE, '1' FROM SCO_IMPORT.IMPORT_TYPE_AP;
  	DBMS_OUTPUT.PUT_LINE('Alimentation de la table Types d''AP : OK');

  	-- Insertion des données d'AP
  	INSERT INTO SCO_SCOLARITE.COMPOSANT (ID_COMPOSANT, TYPE_COMPOSANT_ID, CODE, LL_COMPOSANT)
  	SELECT ID_DEST, '2', CODE, LIBELLE 
  	FROM SCO_IMPORT.IMPORT_AP, SCO_IMPORT.Z_ID 
  	WHERE SCO_IMPORT.Z_ID.ID_SOUR = SCO_IMPORT.IMPORT_AP.ID_AP
  	AND SCO_IMPORT.Z_ID.ID_TYPE = 'AP';
    INSERT INTO SCO_SCOLARITE.AP (ID_AP, TYPE_AP_ID, MODE_AP_ID, VALEUR_HEURES, SEUIL, NB_GROUPES)
  	SELECT ID_DEST, TYPE_AP_ID, MODE_AP_ID, VALEUR_HEURES, SEUIL, NB_GROUPES 
  	FROM SCO_IMPORT.IMPORT_AP, SCO_IMPORT.Z_ID 
  	WHERE SCO_IMPORT.Z_ID.ID_SOUR = SCO_IMPORT.IMPORT_AP.ID_AP
  	AND SCO_IMPORT.Z_ID.ID_TYPE = 'AP';
  	DBMS_OUTPUT.PUT_LINE('Alimentation de la table d''AP : OK');
  
  	-- Insertion des données d'EC
	INSERT INTO SCO_SCOLARITE.COMPOSANT (ID_COMPOSANT, TYPE_COMPOSANT_ID, CODE, LL_COMPOSANT, LC_COMPOSANT)
  	SELECT ID_DEST, '3', CODE, LIBELLE||' ', LIBELLE_COURT
  	FROM SCO_IMPORT.IMPORT_EC, SCO_IMPORT.Z_ID 
  	WHERE SCO_IMPORT.Z_ID.ID_SOUR = SCO_IMPORT.IMPORT_EC.ID_EC
  	AND SCO_IMPORT.Z_ID.ID_TYPE = 'EC';
  	INSERT INTO SCO_SCOLARITE.EC (ID_EC)
  	SELECT ID_DEST FROM SCO_IMPORT.IMPORT_EC, SCO_IMPORT.Z_ID 
  	WHERE SCO_IMPORT.Z_ID.ID_SOUR = SCO_IMPORT.IMPORT_EC.ID_EC
  	AND SCO_IMPORT.Z_ID.ID_TYPE = 'EC';
  	DBMS_OUTPUT.PUT_LINE('Alimentation de la table EC : OK');
  
  	-- Insertion des données de liaison entre AP et EC
	INSERT INTO SCO_SCOLARITE.LIEN (ID_LIEN, PARENT_ID, CHILD_ID, TYPE_LIEN_ID)
  	SELECT SCO_SCOLARITE.LIEN_SEQ.nextval, ALIAS_EC.ID_DEST, ALIAS_AP.ID_DEST, '1'
  	FROM SCO_IMPORT.IMPORT_LIEN, SCO_IMPORT.Z_ID ALIAS_AP, SCO_IMPORT.Z_ID ALIAS_EC
  	WHERE (SCO_IMPORT.IMPORT_LIEN.AP_ID = ALIAS_AP.ID_SOUR
  	AND ALIAS_AP.ID_TYPE = 'AP')
  	AND (SCO_IMPORT.IMPORT_LIEN.EC_ID = ALIAS_EC.ID_SOUR
  	AND ALIAS_EC.ID_TYPE = 'EC');
  	DBMS_OUTPUT.PUT_LINE('Alimentation de la table Lien : OK');
 
  	-- Insertion des données d'UE
	INSERT INTO SCO_SCOLARITE.COMPOSANT (ID_COMPOSANT, TYPE_COMPOSANT_ID, DOMAINE_ID, CODE, LL_COMPOSANT, LC_COMPOSANT)
  	SELECT ID_DEST, '4', DOMAINE_ID, CODE, LIBELLE||' ', LIBELLE_COURT
  	FROM SCO_IMPORT.IMPORT_UE, SCO_IMPORT.Z_ID 
  	WHERE SCO_IMPORT.Z_ID.ID_SOUR = SCO_IMPORT.IMPORT_UE.ID_UE
  	AND SCO_IMPORT.Z_ID.ID_TYPE = 'UE';
  	INSERT INTO SCO_SCOLARITE.UE (ID_UE)
  	SELECT ID_DEST FROM SCO_IMPORT.IMPORT_UE, SCO_IMPORT.Z_ID 
  	WHERE SCO_IMPORT.Z_ID.ID_SOUR = SCO_IMPORT.IMPORT_UE.ID_UE
  	AND SCO_IMPORT.Z_ID.ID_TYPE = 'UE';
  	DBMS_OUTPUT.PUT_LINE('Alimentation de la table UE : OK');
  
  	-- Insertion des données de PARCOURS
	/* INSERT INTO SCO_SCOLARITE.PARCOURS
	(ID, SPECIALITE_ID, VOCATION_ID, CODE, LIBELLE_COURT, LIBELLE)
	SELECT IMPORT_PARCOURS_SEQ.nextval, SCO_IMPORT.IMPORT_SPECIALISATION.ID, SCO_IMPORT.IMPORT_VOCATION.ID, MPAR_CODE, MPAR_ABREVIATION, MPAR_LIBELLE
	FROM SCOLARITE.SCOL_MAQUETTE_PARCOURS, SCO_IMPORT.IMPORT_SPECIALISATION, SCO_IMPORT.IMPORT_VOCATION
  	WHERE SCOLARITE.SCOL_MAQUETTE_PARCOURS.FSPN_KEY = SCO_IMPORT.IMPORT_SPECIALISATION.KEY
  	AND SCOLARITE.SCOL_MAQUETTE_PARCOURS.FVOC_CODE = SCO_IMPORT.IMPORT_VOCATION.CODE;
	DBMS_OUTPUT.PUT_LINE('Alimentation de la table Pacours : OK'); */
  
  	-- Insertion des données de DIPLOME
  	INSERT INTO SCO_SCOLARITE.COMPOSANT (ID_COMPOSANT, TYPE_COMPOSANT_ID, DOMAINE_ID, CODE, LL_COMPOSANT, LC_COMPOSANT)
  	SELECT ID_DEST, '9', DOMAINE_ID, CODE, LIBELLE||' ', LIBELLE_COURT
  	FROM SCO_IMPORT.IMPORT_DIPLOME, SCO_IMPORT.Z_ID 
  	WHERE SCO_IMPORT.Z_ID.ID_SOUR = SCO_IMPORT.IMPORT_DIPLOME.ID_DIPLOME
  	AND SCO_IMPORT.Z_ID.ID_TYPE = 'DI';
    INSERT INTO SCO_SCOLARITE.DIPLOME
	(ID_DIPLOME, GRADE_UNIVERSITAIRE_ID, TYPE_ORGANISATION_ID, TYPE_FORMATION_ID, STATUT_FORMATION_ID, SISE_MESR, MENTION)
	SELECT ID_DEST, GRADE_UNIVERSITAIRE.ID_GRADE_UNIVERSITAIRE, TYPE_ORGANISATION.ID_TYPE_ORGANISATION, '1', STATUT_FORMATION.ID_STATUT_FORMATION, SISE_MESR, MENTION
	FROM SCO_IMPORT.IMPORT_DIPLOME, SCO_IMPORT.Z_ID, SCO_IMPORT.IMPORT_STATUT_FORMATION, SCO_SCOLARITE.STATUT_FORMATION, SCO_IMPORT.IMPORT_TYPE_ORGANISATION, SCO_SCOLARITE.TYPE_ORGANISATION, SCO_IMPORT.IMPORT_GRADE, SCO_SCOLARITE.GRADE_UNIVERSITAIRE 
  	WHERE SCO_IMPORT.Z_ID.ID_SOUR = SCO_IMPORT.IMPORT_DIPLOME.ID_DIPLOME
  	AND SCO_IMPORT.Z_ID.ID_TYPE = 'DI'
  	AND SCO_IMPORT.IMPORT_DIPLOME.GRADE_UNIVERSITAIRE_ID = SCO_IMPORT.IMPORT_GRADE.ID_GRADE
  	AND SCO_IMPORT.IMPORT_GRADE.CODE = SCO_SCOLARITE.GRADE_UNIVERSITAIRE.TYPE_GRADE_UNIVERSITAIRE
  	AND SCO_IMPORT.IMPORT_DIPLOME.TYPE_ORGANISATION_ID = SCO_IMPORT.IMPORT_TYPE_ORGANISATION.ID_TYPE_ORGANISATION
  	AND SCO_IMPORT.IMPORT_TYPE_ORGANISATION.CODE = SUBSTR(SCO_SCOLARITE.TYPE_ORGANISATION.TYPE_ORGANISATION, 0, 1)
  	AND SCO_IMPORT.IMPORT_DIPLOME.STATUT_FORMATION_ID = SCO_IMPORT.IMPORT_STATUT_FORMATION.ID_STATUT_FORMATION
  	AND SCO_IMPORT.IMPORT_STATUT_FORMATION.CODE = SCO_SCOLARITE.STATUT_FORMATION.CODE;
	DBMS_OUTPUT.PUT_LINE('Alimentation de la table Diplomes : OK');

  	COMMIT;  

END;
